/***********************************************************************/
/*                                                                     */
/*   SVMTorch                                                          */
/*                                                                     */
/*   Author: Ronan Collobert                                           */
/*   Date: 21.07.2000                                                  */
/*                                                                     */
/*   Copyright (c) 2000  IDIAP - All rights reserved                   */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/
  

#include "chunker.h"

/*
void setIOptimizer(QCMoptimizer &the_i_opti)
{
	i_opti = &the_i_opti;
	i_opti_is_set = true;
}
*/

void chunkerInit(void)
{
 	i_opti_is_set = false;

#ifdef USEDOUBLE	
	setCstes(2, 1E-9, 100, 10, 40);
#else
	setCstes(2, 1E-4, 100, 10, 40);
#endif

	setIPrecision(1E-4);

	debug = 0;
	precision = 0.01;
	C = 100;
	epsilon = 0.5;
}

void setCstes(int the_chunk_size, real the_eps, int the_iter_min_to_shrink, int the_proportion_to_shrink, real the_cache_size_mega)
{
	chunk_size = the_chunk_size;
	eps = the_eps;
	iter_min_to_shrink = the_iter_min_to_shrink;
	proportion_to_shrink = the_proportion_to_shrink;
	cache_size = (int)(the_cache_size_mega * 1048576);
}

void fatalError(char *str)
{
	printf("\nFATAL error: %s\n\n", str);
	exit(0);
}

#ifdef I_WANT_TIME
long getRuntime(void) 
{
        struct tms buffer;
        times(&buffer);
        return((long)(buffer.tms_utime+buffer.tms_stime));
}
#endif


/*-------------- Supplementary methods ----------------------*/

void setChunkSize(int the_chunk_size)
{
	chunk_size = the_chunk_size;
}

void setEps(real the_eps)
{
	eps = the_eps;
}

void setIterMinToShrink(int the_iter_min_to_shrink)
{
	iter_min_to_shrink = the_iter_min_to_shrink;
}

void setProportionToShrink(int the_proportion_to_shrink)
{
	proportion_to_shrink = the_proportion_to_shrink;
}

void setCacheSize(int the_cache_size_mega)
{
	cache_size = (int)(the_cache_size_mega * 1048576);
}

void setIPrecision(real the_i_precision)
{
	i_precision = the_i_precision;
}
